#
# Online Timesheet Product
#
# (C) Copyright 2001 The Internet (Aust) Pty Ltd
# ACN: 082 081 472  ABN: 83 082 081 472
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# Author: Andrew Milton <akm@theinternet.com.au>

import App, Globals, OFS, Acquisition
import string
from ImageFile import ImageFile
from Globals import DTMLFile

from Persistence import Persistent
from Globals import HTMLFile, HTML
from OFS.Folder import Folder

def manage_addClient(self, name, address, city, state, postcode,
					 country, default_bill_rate=0.0, REQUEST={}):
	""" Add a new Client """
	self.sqlInsertClient(name=name, address=address, city=city,
						 state=state, postcode=postcode, country=country,
						 default_bill_rate=default_bill_rate)

	if REQUEST:
		return self.manage_main(self, REQUEST)
	return ''


def manage_editClient(self, client_id, name, address, city, state, postcode,
					  country, default_bill_rate=0.0, REQUEST={}):
	""" Edit a Client """
	self.sqlUpdateClient(name=name, address=address, city=city,
						 state=state, postcode=postcode, country=country,
						 default_bill_rate=default_bill_rate,
						 client_id=client_id)

	if REQUEST:
		return self.manage_main(self, REQUEST)
	return ''
		
manage_addClientForm=DTMLFile('manage_addClientForm', globals())
manage_editClientForm=DTMLFile('manage_editClientForm',globals())

class Client(Acquisition.Implicit):
	def __init__(self, client_id, name, address, city, state, postcode,
				 country, default_bill_rate=0.0):
		self.client_id=client_id
		self.client_name=name
		self.address=address
		self.city=city
		self.state=state
		self.postcode=postcode
		self.country=country
		self.default_bill_rate=default_bill_rate
		
	def getProjects(self):
		return self.sqlGetClientProjects(client_id=self.client_id)
