#
# Online Timesheet Product
#
# (C) Copyright 2001 The Internet (Aust) Pty Ltd
# ACN: 082 081 472  ABN: 83 082 081 472
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# Author: Andrew Milton <akm@theinternet.com.au>

import Acquisition
from SQLHelpers import sqlattr


class TimesheetEntry(Acquisition.Implicit):
	statusNames=['Open', 'Pending', 'Approved']
	def __init__(self, sqlResults):
		self.total_hours=0
		self.status=len(self.statusNames)
		self.project_id=0
		self.days=[]
		for i in range(7):
			self.days.append(0)

		for d in sqlResults:
			status=sqlattr(d, 'status')
			if status < self.status:
				self.status=status
			dow=sqlattr(d, 'dow')
			th=sqlattr(d,'total_hours')
			self.days[dow]=self.days[dow]+th
			self.total_hours=self.total_hours+th
			try:
				self.category_id=sqlattr(d, 'category_id')				
				self.project_id=sqlattr(d, 'project_id')
			except:
				pass
		
			
		
	def getStatusName(self):
		""" bleh """
		return self.statusNames[self.status]

class MemberTimesheetEntry(Acquisition.Implicit):
	statusNames=['Open', 'Pending', 'Approved']
	def __init__(self, sqlRow):
		self.days=[]
		for i in range(7):
			self.days.append(0)

		self.member_id=sqlattr(sqlRow,'member_id')
		self.status=sqlattr(sqlRow, 'status')
		self.total_hours=sqlattr(sqlRow,'total_hours')
		self.days[0]=sqlattr(sqlRow, 'mon_hours')
		self.days[1]=sqlattr(sqlRow, 'tue_hours')
		self.days[2]=sqlattr(sqlRow, 'wed_hours')
		self.days[3]=sqlattr(sqlRow, 'thu_hours')
		self.days[4]=sqlattr(sqlRow, 'fri_hours')
		self.days[5]=sqlattr(sqlRow, 'sat_hours')
		self.days[6]=sqlattr(sqlRow, 'sun_hours')		
		self.category_id=sqlattr(sqlRow, 'category_id')				
		self.project_id=sqlattr(sqlRow, 'project_id')
		self.is_billable=sqlattr(sqlRow, 'billable')
		self.year = sqlattr(sqlRow, 'year')
		self.week = sqlattr(sqlRow, 'week')
	
	def getStatusName(self):
		""" bleh """
		return self.statusNames[self.status]
